# Loader : Copyright (c) 2004, David G. Drumright (ockham) : as of 8/31/04
# Variant that locates	"physical" things on a grid with random, Oct 4, 04

import os
import math
import glob
import string
import shutil
from Tkinter import *
import tkMessageBox
import random
import poser
scene=poser.Scene()

global IniName
global BasePath
global Patterns
global DefaultDirs
global LatestDirs
global FileList
global PossDrives
global StuffLabel
global DirDisplayList
global DirFullList
global BaseFig
global SearchList
global LocatablesList

BasePathUncut=poser.AppLocation()
BasePath=BasePathUncut[:(-len('poser.exe'))]
IniName=os.path.normpath(BasePath+'Loader.ini')
PossDrives=['A:/']
BaseFig=0

NOPs='*'
CR2s='*.CR2 *.CRZ'
PZ2s='*.PZ2 *.P2Z'
FC2s='*.FC2 *.FCZ'
HR2s='*.HR2 *.HRZ *.CR2 *.CRZ *.PP2 *.P2Z'
HD2s='*.HD2 *.HDZ'
PP2s='*.PP2 *.PPZ *.P2Z *.CR2 *.CRZ'
LT2s='*.LT2 *.LTZ'
CM2s='*.CM2 *.CMZ'
OBJs='*.OBJ *.3DS *.BVH *.DXF *.3DM* *.LWO'
MORs='*.OBJ'
ETCs='*.PZ3 *.PZZ *.PP2 *.PPZ *.PZ2 *.P2Z *.CR2 *.CRZ *.FC2 *.FCZ *.HD2 *.HDZ *.LT2 *.LTZ *.CM2 *.CMZ'

Patterns=[ NOPs, CR2s, CR2s, PZ2s, PZ2s, PZ2s, PZ2s, PZ2s, PZ2s,
	FC2s, FC2s, HR2s, HR2s, HD2s, HD2s, PP2s, PP2s, LT2s, LT2s, CM2s,
	CM2s, OBJs, MORs, ETCs, ETCs ]

RB='Runtime/'
LB=RB+'Libraries/'
CB=LB+'character/'
PP=CB+'People/'
PS=LB+'Pose/Pose Sets/'
CF=CB+'Clothing-Female/'
CM=CB+'Clothing-Male/'
if float(poser.Version()) >= 5.0:
	PT=LB+'props/Primitives/'
else:
	PT=LB+'props/Prop Types/'
BE=LB+'face/Basic Expressions/'
HT=LB+'hair/Hair Types/'
BH=LB+'hand/Basic Hands/'
LS=LB+'light/Light Sets/'
CS=LB+'camera/Camera Sets/'
OB=RB+'Geometries/props/'
MT=LB+'morphs/'

DefaultDirs=[ RB, PP, CF, PS, PS, PS, PS, PS, PS, BE, BE, HT, HT,
	BH, BH, PT, PT, LS, LS, CS, CS, OB, MT, CF, CF ]


LatestDirs=[]
FileList=[]
StuffLabel='STUFF'
DirDisplayList=[]
DirFullList=[]
SearchList={}
LocatablesList=[]

def lccompare(a,b):
	return cmp(string.lower(a), string.lower(b))
def FindOBJ(Matcher,dirname,names):
	global SearchList
	UpPat=string.upper(Matcher)
	for OneBaseName in names:
		if string.count(string.upper(OneBaseName),UpPat):
			SearchList[OneBaseName]=dirname


class App:
	def __init__(self, master, textMessage):
		global StuffLabel
		self.master=master
		master.title('Loader')
		self.Quantity=1
		self.Choice=0
		self.StartIni()

		self.FileTypeVar=IntVar()
		self.FileTypeVar.set(self.Choice)
		self.LocTightVar=IntVar()
		self.LocTightVar.set(0)
		self.LocLooseVar=IntVar()
		self.LocLooseVar.set(0)

		self.ButtonFrame=Frame(self.master,bg='white',borderwidth=2,relief=RIDGE)
		self.ButtonFrame.grid(row=1,column=0,padx=5)
		self.FileFrame=Frame(self.master,bg='white',borderwidth=2,relief=RIDGE)
		self.FileFrame.grid(row=1,column=1,padx=5)

		# new 9/22/04
		self.LocationFrame=Frame(self.master,bg='white',borderwidth=2,relief=RIDGE)
		self.LocationFrame.grid(row=2,column=0,padx=5)


		Titles1=['FIGURE:', 'POSE:', 'MAT POSE:','MOR POSE:','FACE:','HAIR:', 'HAND:', 'PROP:', 'LIGHT:', 'CAMERA:', 'IMPORT:']

		Titles2=['default', 'default', '1', '1', 'default', 'default','left', 'default', 'default', 'default', 'mesh']

		Titles3=['conformed','mirror', '2', '2', 'mirror', 'parented','right', 'parented', 'parented', 'parented','morph']

		R=0
		V=1
		self.Buttons={}
		for R in range(11):
			Label(self.ButtonFrame, text=Titles1[R],bg='white').grid(row=R, column=0,sticky=W)
			Label(self.ButtonFrame, text=Titles2[R],bg='white').grid(row=R, column=1,sticky=E)
			self.Buttons[V]=Radiobutton(self.ButtonFrame,bg='white',variable=self.FileTypeVar,value=V)
			self.Buttons[V].grid(row=R, column=2)
			V=V+1
			Label(self.ButtonFrame, text=Titles3[R],bg='white').grid(row=R, column=3,sticky=E)
			self.Buttons[V]=Radiobutton(self.ButtonFrame,bg='white',variable=self.FileTypeVar,value=V)
			self.Buttons[V].grid(row=R, column=4)
			V=V+1

		self.What1Entry=Entry(self.ButtonFrame,bg='white',width=10)
		self.What1Entry.grid(row=12, column=0)
		Label(self.ButtonFrame, text='default',bg='white').grid(row=12, column=1)
		self.Buttons[V]=Radiobutton(self.ButtonFrame,bg='white',variable=self.FileTypeVar,value=V)
		self.Buttons[V].grid(row=12, column=2)
		V=V+1
		Label(self.ButtonFrame, text='parented',bg='white').grid(row=12, column=3)
		self.Buttons[V]=Radiobutton(self.ButtonFrame,bg='white',variable=self.FileTypeVar,value=V)
		self.Buttons[V].grid(row=12, column=4)
		self.What1Entry.insert(0,StuffLabel)
		V=V+1

		Label(self.FileFrame, text='Quantity:',bg='white').grid(row=0, column=2,sticky=E)
		self.QuantityEntry=Entry(self.FileFrame,bg='white',width=4)
		self.QuantityEntry.grid(row=0, column=3)
		self.QuantityEntry.delete(0,'end')
		self.QuantityEntry.insert(0,'1')

		self.DirListYScroll=Scrollbar(self.FileFrame, orient=VERTICAL)
		self.DirListYScroll.grid( row=1, column=0,sticky=N+S+E)
		self.DirListXScroll=Scrollbar(self.FileFrame, orient=HORIZONTAL)
		self.DirListXScroll.grid( row=2, column=1)
		self.DirListBox=Listbox(self.FileFrame, height=25, selectmode=SINGLE,
								  yscrollcommand=self.DirListYScroll.set,
								  xscrollcommand=self.DirListXScroll.set,exportselection=0)
		self.DirListBox.grid( row=1, column=1)
		self.DirListXScroll['command']=self.DirListBox.xview
		self.DirListYScroll['command']=self.DirListBox.yview

		self.FileListYScroll=Scrollbar(self.FileFrame, orient=VERTICAL)
		self.FileListYScroll.grid( row=1, column=3,sticky=N+S+E)
		self.FileListBox=Listbox(self.FileFrame, height=25, selectmode=MULTIPLE,
								   yscrollcommand=self.FileListYScroll.set,exportselection=0)
		self.FileListBox.grid( row=1, column=2)
		self.FileListYScroll['command']=self.FileListBox.yview

		self.UndoButton=Button(self.FileFrame,text='Undo', command=self.HandleUndo)
		self.UndoButton.grid(row=0, column=1)
		self.UndoButton.configure(state=DISABLED)
		self.GoButton=Button(self.FileFrame,text='Go!', bg='pink',command=self.HandleGo)
		self.GoButton.grid(row=2, column=2,pady=2)



		# new 9/22/04.	Add choice for location: checkbox for Locate and entry for Randomize %.
		Label(self.LocationFrame, text='Locate:',bg='white').grid(row=0, column=0,sticky=W)
		Label(self.LocationFrame, text='Tight',bg='white').grid(row=0, column=1,sticky=E)
		self.LocBox=Checkbutton(self.LocationFrame,bg='white',var=self.LocTightVar)
		self.LocBox.grid(row=0, column=2)
		Label(self.LocationFrame, text='Loose',bg='white').grid(row=0, column=3,sticky=E)
		self.LocBox=Checkbutton(self.LocationFrame,bg='white',var=self.LocLooseVar)
		self.LocBox.grid(row=0, column=4)
		Label(self.LocationFrame, text='Random %',bg='white').grid(row=0, column=5,sticky=E)
		self.LocRandEntry=Entry(self.LocationFrame,bg='white',width=4)
		self.LocRandEntry.grid(row=0, column=6)
		# END new 9/22/04

		for V in self.Buttons.keys():
			self.Buttons[V].bind('<Button-1>',self.HandleDots)
		self.DirListBox.bind('<Double-Button-1>',self.HandleSelectDir)

		self.FileTypeVar.set(self.Choice)
		if self.Choice > 0:
			self.Buttons[self.Choice].select()
			if (self.Choice != 4) and (self.Choice != 6):
				self.FillDirList()
				self.FillFileList()
		self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)


	def HandleCancel(self):
		root.destroy()

	def Update(self):
		scene.ProcessSomeEvents(1)
		root.lift()
		root.after(150, self.Update)

	def SwapAll(self):
		global BaseFig
		if not BaseFig: return
		scene.SetFrame(0)

		BaseFig.SwapTop()
		BaseFig.SwapBottom()
		MidlineList=["Neck","Head","Chest","Abdomen","Hip","Left Eye","Right Eye"]
		for Name in MidlineList:
			try:
				OneActor=BaseFig.Actor(Name)
			except:
				pass
			try:
				TwistParm=OneActor.ParameterByCode(poser.kParmCodeYROT)
				TwistParm.SetValue(-TwistParm.Value())
			except:
				pass
			try:
				SideParm=OneActor.ParameterByCode(poser.kParmCodeZROT)
				SideParm.SetValue(-SideParm.Value())
			except:
				pass


	def SwapFace(self,OneFile):
		global BaseFig
		if not BaseFig: return
		try:
			OneActor=BaseFig.Actor("Head")
		except:
			return
		MTList={}

		for OneActor in BaseFig.Actors():
			AN = OneActor.Name()
			MTList[AN] = {}
			for OneParm in OneActor.Parameters():
				if OneParm.IsMorphTarget():
					PN = OneParm.Name()
					PV = OneParm.Value()
					MTList[AN][string.strip(string.upper(PN))] = (PN,PV)

		scene.LoadLibraryFace(OneFile)
		for AN in MTList.keys():
			OneActor = BaseFig.Actor(AN)
			Subdict = MTList[AN]
			OppDict={}
			for N in Subdict.keys():
				(RealN,oldV) = Subdict[N]
				if N[0]=='L':
					OppName = 'R' + N[1:]
					if OppName in Subdict.keys():
						OppDict[N]=OppName
					OppName = string.replace(N,'L','RIGHT',1)
					if OppName in Subdict.keys():
						OppDict[N]=OppName

				elif N[-1]=='L':
					OppName = N[:-1]+'R'
					if OppName in Subdict.keys():
						OppDict[N]=OppName
					OppName = N[:-1]+'RIGHT'
					if OppName in Subdict.keys():
						OppDict[N]=OppName

				elif string.count(N,'LEFT'):
					OppName = string.replace(N,'LEFT','R')
					if OppName in Subdict.keys():
						OppDict[N]=OppName
					OppName = string.replace(N,'LEFT','RIGHT')
					if OppName in Subdict.keys():
						OppDict[N]=OppName

			for UpperL in OppDict.keys():
				RealL,OldLval = Subdict[UpperL]
				UpperR = OppDict[UpperL]
				RealR,OldRval = Subdict[UpperR]
				NewLval = OneActor.Parameter(RealL).Value()
				NewRval = OneActor.Parameter(RealR).Value()
				if (NewLval != OldLval) or (NewRval != OldRval):
					OneActor.Parameter(RealR).SetValue(NewLval)
					OneActor.Parameter(RealL).SetValue(NewRval)

	def SpawnMT(self,ObjFileName):
		TheFigure=0
		TheActor=scene.CurrentActor()
		if (not TheActor.IsProp()) and (not TheActor.IsBodyPart()):
			return
		if (TheActor.Name() == 'UNIVERSE') or (TheActor.Name() == 'GROUND'):
			return

		try:
			fp=open(ObjFileName,'rb')
		except:
			return 0

		MainName,ExtName=os.path.splitext(os.path.basename(ObjFileName))

		TheActor.SpawnTarget(MainName)
		NewMTParm=TheActor.Parameter(MainName)

		DeltaX=0.0
		DeltaY=0.0
		DeltaZ=0.0

		OldGeom=TheActor.Geometry()
		NumVerts=OldGeom.NumVertices()

		Index=0
		LineParts=[]
		while Index < (NumVerts-1):
		   try:
			  st=fp.readline()
		   except:
			  break
		   S=string.split(st)
		   if not S: continue
		   elif not S[0]: continue
		   elif S[0] == 'v':
			   OneVert=OldGeom.Vertex(Index)
			   DeltaX=float(S[1])-OneVert.X()
			   DeltaY=float(S[2])-OneVert.Y()
			   DeltaZ=float(S[3])-OneVert.Z()
			   NewMTParm.SetMorphTargetDelta(Index, DeltaX, DeltaY, DeltaZ)
			   Index=Index+1
		fp.close()


	def StartIni(self):
		global DefaultDirs
		global LatestDirs
		global PossDrives
		global StuffLabel

		LettersNoA='BCDEFGHIJKLMNOPQRSTUVWXYZ'
		for i in LettersNoA:
			PathStr='%s:/' % i
			if os.path.exists(PathStr):
				PossDrives.append(PathStr)

		if not os.path.exists(IniName):
			fp=open(IniName,'w')
			fp.write('0\n')
			st=StuffLabel+'\n'
			fp.write(st)
			for OneString in DefaultDirs:
				st=BasePath+OneString+'\n'
				fp.write(st)
			fp.close()
		fp=open(IniName,'r')
		LatestDirs=[]
		self.Choice=int(fp.readline())
		StuffLabel=string.rstrip(fp.readline())
		while 1:
			st=fp.readline()
			if not st: break
			stcut=string.rstrip(st)
			LatestDirs.append(stcut)
		fp.close()


	def WriteIni(self):
		global StuffLabel
		try:
			fp=open(IniName,'w')
		except:
			tkMessageBox.showerror(IniName, 'Unable to write INI file')
			exit
		fp.write(str(self.Choice)+'\n')
		StuffLabel=self.What1Entry.get()
		st=StuffLabel+'\n'
		fp.write(st)
		for OneString in LatestDirs:
			st='%s\n' % OneString
			fp.write(st)
		fp.close()


	def FillDirListMyComputer(self):
		global DirDisplayList
		global DirFullList
		DirDisplayList=[]
		DirFullList=[]
		self.DirListBox.delete(0,END)
		DirDisplayList.append('My Computer')
		DirFullList.append('/')
		for OneDir in PossDrives:
			DirDisplayList.append(OneDir)
			DirFullList.append(OneDir)
		for i in range(len(DirDisplayList)):
			OldStr=DirDisplayList[i]
			if i == 0:
				NewStr=OldStr
			else:
				NewStr=(' ')+OldStr
			self.DirListBox.insert(END,NewStr)
		self.FileListBox.delete(0,END)
		self.DirListBox.selection_set(0)

	def FillDirList(self):
		global DirDisplayList
		global DirFullList
		DirDisplayList=[]
		DirFullList=[]
		self.DirListBox.delete(0,END)
		CurrentDir=LatestDirs[self.Choice]
		CurDirNorm=os.path.normpath(CurrentDir)
		Rootmost,Rest=os.path.split(CurDirNorm)
		DirDisplayList.insert(0,Rest)
		DirFullList.insert(0,CurDirNorm)
		Rootmost=CurDirNorm
		for n in range(100):
			 Rootmost,Rest=os.path.split(Rootmost)
			 Dummy,ListItem=os.path.split(Rootmost)
			 if not ListItem:
				 break
			 DirDisplayList.insert(0,ListItem)
			 DirFullList.insert(0,Rootmost)
		Dummy=string.replace(Dummy,'\\\\','\\')
		DirDisplayList.insert(0,Dummy)
		DirFullList.insert(0,Dummy)
		DirDisplayList.insert(0,'My Computer')
		DirFullList.insert(0,'My Computer')
		IndexOfCurrent=len(DirDisplayList)-1
		ChildFind=CurDirNorm+'/*'
		ChildList=glob.glob(ChildFind)
		ChildList.sort(lccompare)
		for OneDir in ChildList:
			if os.path.isdir(OneDir):
				if OneDir != CurDirNorm:
					Dummy,Rest=os.path.split(OneDir)
					DirDisplayList.append(Rest)
					DirFullList.append(OneDir)
		for i in range(len(DirDisplayList)):
			OldStr=DirDisplayList[i]
			if i <= IndexOfCurrent:
				NewStr=(' ' * i)+OldStr
			else:
				NewStr=(' ' * (1+IndexOfCurrent))+OldStr
			self.DirListBox.insert(END,NewStr)
		self.DirListBox.selection_set(IndexOfCurrent)

	def HandleSelectDir(self,event):
		global LatestDirs
		Selecteds=event.widget.curselection()
		Index=int(Selecteds[0])
		if Index == 0:
			LatestDirs[self.Choice]='/'
			self.FillDirListMyComputer()
			self.FillFileList()
		else:
			LatestDirs[self.Choice]=DirFullList[Index]
			self.FillDirList()
			self.FillFileList()


	def FillFileList(self):
		global FileList
		global LatestDirs
		global Patterns
		PresentDir=LatestDirs[self.Choice]
		PresentFileTypes=Patterns[self.Choice]
		FT=string.split(PresentFileTypes)
		self.FileListBox.delete(0,END)
		FileList =[]
		for OneType in FT:
		   FullType=os.path.normpath(PresentDir+'/'+OneType)
		   ListPart=glob.glob(FullType)
		   for OneFullPath in ListPart:
				FileList.append(OneFullPath)
		FileList.sort(lccompare)
		for OneFullPath in FileList:
			self.FileListBox.insert(END,os.path.basename(OneFullPath))

	def HandleDots(self,event):
		self.Choice=int(event.widget.cget('value'))
		if (self.Choice != 4) and (self.Choice != 6):
			self.FillDirList()
			self.FillFileList()

	def HandleUndo(self):
		if (self.Choice >= 3) and (self.Choice <= 8):
			if not BaseFig: return
			BaseFig.Reset()
		elif self.Choice == 9 or self.Choice == 10:
			if not BaseFig: return
			FaceActor=BaseFig.Actor('Head')
			FaceActor.Reset()
		self.UndoButton.configure(state=DISABLED)

	def Locate(self,Boxer):
		global LocatablesList
		IsFig=0

		# Takes the selected item before the load as the bounding box.
		# (reminder: after loading, currentactor is not the original!)

		# If Checkbox not checked, just clear the list of locatable items.
		Tight=self.LocTightVar.get()
		Loose=self.LocLooseVar.get()
		if not Tight and not Loose:
			del LocatablesList[:]
			return

		RP=self.LocRandEntry.get()
		if RP: RandProp=float(RP)/100.0
		else:  RandProp=0.0 # The location always uses RandProp, so it must be 0 when not set.


		# In all cases we get the center and dims of the bounding box.
		# When Tight is wanted, we also get the dims of one of the loaded items,
		# and try to fit the items closely.  When Loose, we don't need the item dim;
		# just space things evenly in the box.	Random starts with Loose and then
		# moves things around a bit.

		# Get the bounding box of the currently selected item, which is the Container.
		if (not Boxer.IsBodyPart()) and (not Boxer.IsProp()): return # Not suitable; just quietly return
		scene.DrawAll()
		# Get the bounding box.
		MaxX=-10000.0
		MaxY=-10000.0
		MaxZ=-10000.0
		MinX= 10000.0
		MinY= 10000.0
		MinZ= 10000.0
		BaseGeom=Boxer.Geometry()
		# Do a full-range loop here; these dimensions are more critical, and
		# the box is likely to be a simple thing.  Use only the X and Z for
		# now.	It's not clear that we need a 3-dim grid.
		for Vindex in range(BaseGeom.NumVertices()):
			OneVert=BaseGeom.WorldVertex(Vindex)
			X=OneVert.X()
			Y=OneVert.Y()
			Z=OneVert.Z()
			if	 X < MinX: MinX = X
			elif X > MaxX: MaxX = X
			if	 Y < MinY: MinY = Y
			elif Y > MaxY: MaxY = Y
			if	 Z < MinZ: MinZ = Z
			elif Z > MaxZ: MaxZ = Z

		# For easier figuring, find the center and widths:
		CenterX = (MaxX + MinX) / 2.0  # Midpoint
		CenterY = (MaxY + MinY) / 2.0
		CenterZ = (MaxZ + MinZ) / 2.0
		BoxDimX  = abs(MaxX - MinX)
		BoxDimY  = abs(MaxY - MinY)
		BoxDimZ  = abs(MaxZ - MinZ)
		if BoxDimX < 0.01: BoxDimX = 0.01 # Protect div0
		if BoxDimY < 0.01: BoxDimY = 0.01 # Protect div0
		if BoxDimZ < 0.01: BoxDimZ = 0.01
		BoxRadX=BoxDimX/2.0
		BoxRadY=BoxDimY/2.0
		BoxRadZ=BoxDimZ/2.0
		BoxMinX=CenterX-BoxRadX
		BoxMinY=CenterY-BoxRadY
		BoxMinZ=CenterZ-BoxRadZ
		BoxMaxX=CenterX+BoxRadX
		BoxMaxY=CenterY+BoxRadY
		BoxMaxZ=CenterZ+BoxRadZ

		# Use the list of locatable things:
		Count=len(LocatablesList)
		# Check whether the locatable is a figure. (This needs
		# to happen before the Tight/Loose stuff)
		SamplePartName=LocatablesList[0]
		IsFig=1
		try:
			SamplePart=scene.Figure(SamplePartName)
		except:
			IsFig=0

		# Now we distinguish Tight from Loose.
		if Tight:
			# Get the bounding box of the part in its loaded state.  Use the
			# first item in the list as the sample; if we've made it this
			# far, we know there's one item in the list.  The part has to
			# be either a figure name or a prop name.
			if IsFig:
				SamplePart=scene.Figure(SamplePartName)
			else:
				SamplePart=scene.Actor(SamplePartName)
			MaxX=-10000.0
			MinX= 10000.0
			MaxY=-10000.0
			MinY= 10000.0
			MaxZ=-10000.0
			MinZ= 10000.0
			if IsFig:
				SamplePart=scene.Figure(SamplePartName)
				BodyActor=SamplePart.ParentActor()
				PartCenterX=BodyActor.ParameterByCode(poser.kParmCodeXTRAN).Value()
				PartCenterY=BodyActor.ParameterByCode(poser.kParmCodeYTRAN).Value()
				PartCenterZ=BodyActor.ParameterByCode(poser.kParmCodeZTRAN).Value()
				# Use a cheat that should work fairly well.  Take the height of
				# Left Toe as bottom. Take the height of Left Eye + 10% as top.
				# Take the distance from center of Left Hand as the radius for both X and Z
				# If we can't find any of these, do a max-min on all parts.
				try:
					TopActor=SamplePart.Actor("Left Eye")
					MaxY=TopActor.Geometry().WorldVertex(0).Y() * 1.1 # Add 10% to get above top of head
					BotActor=SamplePart.Actor("Left Toe")
					MinY=BotActor.Geometry().WorldVertex(0).Y()
					SideActor=SamplePart.Actor("Left Hand")
					SideX=SideActor.Geometry().WorldVertex(0).X()
					# Form a square on X and Z, using this value as 'radius'
					MaxX=PartCenterX+abs(SideX)
					MinX=PartCenterX-abs(SideX)
					MaxZ=PartCenterZ+abs(SideX)
					MinZ=PartCenterZ-abs(SideX)

				except: # Can't find one of the parts. Check first vert of all parts.
					for OneActor in SamplePart.Actors():
						WV=OneActor.Geometry().WorldVertex(0)
						if	 WV.X() < MinX: MinX=WV.X()
						elif WV.X() > MaxX: MaxX=WV.X()
						if	 WV.Y() < MinY: MinY=WV.Y()
						elif WV.Y() > MaxY: MaxY=WV.Y()
						if	 WV.Z() < MinZ: MinZ=WV.Z()
						elif WV.Z() > MaxZ: MaxZ=WV.Z()

			else:
				 # not IsFig.  Just assume we have a single prop for convenience. Do a complete check
				 # on all WVs in the prop, instead of checking one vert per body-part as with fig.
				 Geom=SamplePart.Geometry()
				 for Index in range(Geom.NumVertices()):
					 WV=Geom.WorldVertex(Index)
					 if   WV.X() < MinX: MinX=WV.X()
					 elif WV.X() > MaxX: MaxX=WV.X()
					 if   WV.Y() < MinY: MinY=WV.Y()
					 elif WV.Y() > MaxY: MaxY=WV.Y()
					 if   WV.Z() < MinZ: MinZ=WV.Z()
					 elif WV.Z() > MaxZ: MaxZ=WV.Z()
			# At this point, by one method or another, we should have the Max and Min for all three dims.
			PartDimX=abs(MaxX - MinX)
			PartDimY=abs(MaxY - MinY)
			PartDimZ=abs(MaxZ - MinZ)
			# End of actions when Tight.

		elif Loose: # For Loose, ignore size of item.  Ignore the vertical dimension
			# of the box.  Try for a sort-of uniform dist on the flat XZ plane.  Fill
			# up the longest of the two dimensions first.
			Root = math.sqrt(float(Count))
			XZprop=BoxRadX > BoxRadZ
			if XZprop >= 1.0: # X widest
				Xcount=Root * (BoxRadX/BoxRadZ)
				if Xcount < 1.0: Xcount=1.0
				Zcount=Count/Xcount
				if Zcount < 1.0: Zcount=1.0
			else: # Z widest
				Zcount=Root * (BoxRadZ/BoxRadX)
				if Zcount < 1.0: Zcount=1.0
				Xcount=Count/Zcount
				if Xcount < 1.0: Xcount=1.0
			# The PartDims play the role of intervals here.
			PartDimX = BoxDimX / (Xcount + 1.0)
			PartDimY = 0.0
			PartDimZ = BoxDimZ / (Zcount + 1.0)

		# Now we have the Part dims in place by one method or another.
		# Start placing the parts inside the Box, running X fastest, Z next, Y slowest.
		# Note that PartDim's are different values from Tight and Loose.

		PartRadX=PartDimX/2.0
		PartRadY=PartDimY/2.0
		PartRadZ=PartDimZ/2.0
		# Move the starting and ending points inward by half, so that we stay INSIDE
		# the box.	Without this, the outer items are halfway outside the box.
		StartX=BoxMinX+PartRadX
		StartY=BoxMinY	# Exception
		StartZ=BoxMinZ+PartRadZ
		EndX=BoxMaxX-PartRadX
		EndY=BoxMaxY-PartRadY
		EndZ=BoxMaxZ-PartRadZ
		Xordinal=0
		Yordinal=0
		Zordinal=0
		for OneLocName in LocatablesList:
			if IsFig: # Get the BODY
				OneLoc=scene.Figure(OneLocName).ParentActor()
			else:
				OneLoc=scene.Actor(OneLocName)
			LocXtranParm =	OneLoc.ParameterByCode(poser.kParmCodeXTRAN)
			LocYtranParm =	OneLoc.ParameterByCode(poser.kParmCodeYTRAN)
			LocZtranParm =	OneLoc.ParameterByCode(poser.kParmCodeZTRAN)
			# Use the PartDims to locate AND to determine when we bump an edge.
			# The Point vals are locations; the Limit vals are the edge watchers.
			R=1.0+RandProp*(random.random()-0.5)
			PointX=StartX+(Xordinal*PartDimX*R)
			R=1.0+RandProp*(random.random()-0.5)
			PointY=StartY+(Yordinal*PartDimY*R)
			R=1.0+RandProp*(random.random()-0.5)
			PointZ=StartZ+(Zordinal*PartDimZ*R)
			LocXtranParm.SetValue(PointX)
			LocYtranParm.SetValue(PointY)
			LocZtranParm.SetValue(PointZ)
			# Move fastest on X, then Z, then slowest on Y.
			Xordinal=Xordinal+1
			if (PointX+PartRadX) > EndX:
				Xordinal=0
				Zordinal=Zordinal+1
				if (PointZ+PartRadZ) > EndZ:
					Zordinal=0
					Yordinal=Yordinal+1

		del LocatablesList[:] # After loop is done, leave the bottle empty for others

	def HandleGo(self):
		global FileList
		global LocatablesList
		global BaseFig
		try:
			self.Quantity=int(self.QuantityEntry.get())
		except:
			self.Quantity=1
		Cursel=self.FileListBox.curselection()
		if not Cursel: return
		SelectedFiles=[]
		for i in Cursel:
			SelectedFiles.append(FileList[int(i)])
		BaseFig=0
		try:
			BaseFig=scene.CurrentFigure()
		except:
			pass
		TryParent=0
		try:
			TryParent=scene.CurrentActor()
		except:
			pass

		if	self.Choice == 1:
			for OneFile in SelectedFiles:
				for n in range(self.Quantity):
					try:
						scene.LoadLibraryFigure(OneFile)
						# new 9/22
						LocName=scene.CurrentFigure().Name() # Get the Figure name
						LocatablesList.append(LocName)
					except:
						self.master.destroy() # Just get out fast if error

		elif self.Choice == 2:
			for OneFile in SelectedFiles:
				for n in range(self.Quantity):
					try:
						scene.LoadLibraryFigure(OneFile)
						# 9/22 No locate here.
					except:
						self.master.destroy() # Just get out fast if error
					try:
						NewFig=scene.CurrentFigure()
					except:
						NewFig=0
					if BaseFig and NewFig:
						NewFig.SetConformTarget(BaseFig)
						scene.SelectFigure(BaseFig)

		elif (self.Choice == 3) or (self.Choice == 5) or (self.Choice == 7):
			if not BaseFig: return
			BaseFig.Memorize()
			self.UndoButton.configure(state=NORMAL)
			for OneFile in SelectedFiles:
				try:
					scene.LoadLibraryPose(OneFile)
				except:
					pass

		elif (self.Choice == 4) or (self.Choice == 6) or (self.Choice == 8):
			if not BaseFig: return
			BaseFig.Memorize()
			self.UndoButton.configure(state=NORMAL)
			for OneFile in SelectedFiles:
				try:
					scene.LoadLibraryPose(OneFile)
					self.SwapAll()
				except:
					pass

		elif self.Choice == 9:
			if not BaseFig: return
			try:
				FaceActor=BaseFig.Actor('Head')
			except:
				return
			FaceActor.Memorize()
			self.UndoButton.configure(state=NORMAL)
			for OneFile in SelectedFiles:
				try:
					scene.LoadLibraryFace(OneFile)
				except:
					pass

		elif self.Choice == 10:
			if not BaseFig: return
			try:
				FaceActor=BaseFig.Actor('Head')
			except:
				return
			FaceActor.Memorize()
			self.UndoButton.configure(state=NORMAL)
			for OneFile in SelectedFiles:
				self.SwapFace(OneFile)

		elif self.Choice == 11:
			for OneFile in SelectedFiles:
				Main,Ext=os.path.splitext(OneFile)
				Ext=string.upper(Ext)
				try:
					if string.count(Ext,'CR'):
						scene.LoadLibraryFigure(OneFile)
					elif string.count(Ext,'PP'):
						scene.LoadLibraryProp(OneFile)
					elif string.count(Ext,'HR'):
						scene.LoadLibraryHair(OneFile)
				except:
					pass

		elif self.Choice == 12:
			HeadActor=0
			if BaseFig:
				try:
					HeadActor=BaseFig.Actor('Head')
				except:
					pass
			for OneFile in SelectedFiles:
				Main,Ext=os.path.splitext(OneFile)
				Ext=string.upper(Ext)
				try:
					if string.count(Ext,'CR'):
						scene.LoadLibraryFigure(OneFile)
					elif string.count(Ext,'PP'):
						scene.LoadLibraryProp(OneFile)
					elif string.count(Ext,'HR'):
						scene.LoadLibraryHair(OneFile)
				except:
					pass

				if string.count(Ext,'CR'):
					try:
						NewFig=scene.CurrentFigure()
					except:
						NewFig=0
					if BaseFig and NewFig:
						NewFig.SetConformTarget(BaseFig)
						scene.SelectFigure(BaseFig)
				else:
					try:
						NewActor=scene.CurrentActor()
						NewActor.SetParent(HeadActor)
					except:
						pass

		elif self.Choice == 13:
			for OneFile in SelectedFiles:
				try:
					scene.LoadLibraryHand(OneFile,0)
				except:
					pass

		elif self.Choice == 14:
			for OneFile in SelectedFiles:
				try:
					scene.LoadLibraryHand(OneFile,1)
				except:
					pass

		elif self.Choice == 15:
			for OneFile in SelectedFiles:
				for n in range(self.Quantity):
					try:
						scene.LoadLibraryProp(OneFile)
						# new 9/22
						LocName=scene.CurrentActor().Name() # Get the name of newly loaded
						LocatablesList.append(LocName)
					except:
						pass

		elif self.Choice == 16:
			for OneFile in SelectedFiles:
				for n in range(self.Quantity):
					try:
						scene.LoadLibraryProp(OneFile)
						# new 9/22
						LocName=scene.CurrentActor().Name() # Get the name of newly loaded
						LocatablesList.append(LocName)
					except:
						pass
					if TryParent:
						NewProp=scene.CurrentActor()
						NewProp.SetParent(TryParent)

		elif self.Choice == 17:
			for OneFile in SelectedFiles:
				try:
					scene.LoadLibraryLight(OneFile)
				except:
					pass

		elif self.Choice == 18:
			TryParent=0
			try:
				TryParent=scene.CurrentActor()
			except:
				pass
			for OneFile in SelectedFiles:
				try:
					scene.LoadLibraryLight(OneFile)
				except:
					pass
				if TryParent:
					for OneLight in scene.Lights():
						OneLight.SetParent(TryParent)

		elif self.Choice == 19:
			for OneFile in SelectedFiles:
				try:
					scene.LoadLibraryCamera(OneFile)
				except:
					pass

		elif self.Choice == 20:
			for OneFile in SelectedFiles:
				try:
					scene.LoadLibraryCamera(OneFile)
				except:
					pass
				if TryParent:
					for OneCamera in scene.Cameras():
						OneCamera.SetParent(TryParent)

		elif self.Choice == 21:
			imex=scene.ImExporter()
			for OneFile in SelectedFiles:
				Main,Ext=os.path.splitext(OneFile)
				Ext=string.upper(Ext)
				if string.count(Ext,'OBJ'):
					imoptions=imex.ImportOptions('obj', None)
					imoptions[poser.kImOptCodeAUTOSCALE]=0
					for n in range(self.Quantity):
						imex.Import('OBJ', 'File Format OBJ', OneFile, imoptions)
						# new 9/22
						LocName=scene.CurrentActor().Name() # Get the name of newly loaded
						LocatablesList.append(LocName)
				elif string.count(Ext,'3DS'):
					imoptions=imex.ImportOptions('3DS', None)
					imoptions[poser.kImOptCodeAUTOSCALE]=0
					for n in range(self.Quantity):
						imex.Import('3DS', 'File Format 3DS', OneFile, imoptions)
						# new 9/22
						LocName=scene.CurrentActor.Name() # Get the name of newly loaded
						LocatablesList.append(LocName)
				elif string.count(Ext,'BVH'):
					imoptions=imex.ImportOptions('BVH', None)
					imoptions[poser.kImOptCodeAUTOSCALE]=0
					for n in range(self.Quantity):
						imex.Import('BVH',None, OneFile)
				elif string.count(Ext,'DXF'):
					imoptions=imex.ImportOptions('DXF', None)
					imoptions[poser.kImOptCodeAUTOSCALE]=0
					for n in range(self.Quantity):
						imex.Import('DXF', 'File Format DXF', OneFile, imoptions)
						# new 9/22
						LocName=scene.CurrentActor.Name() # Get the name of newly loaded
						LocatablesList.append(LocName)
				elif string.count(Ext,'LWO'):
					imoptions=imex.ImportOptions('LWO', None)
					imoptions[poser.kImOptCodeAUTOSCALE]=0
					for n in range(self.Quantity):
						imex.Import('LWO', 'File Format LWO', OneFile, imoptions)
						# new 9/22
						LocName=scene.CurrentActor.Name() # Get the name of newly loaded
						LocatablesList.append(LocName)
				elif string.count(Ext,'3DM'):
					imoptions=imex.ImportOptions('3DMF', None)
					imoptions[poser.kImOptCodeAUTOSCALE]=0
					for n in range(self.Quantity):
						imex.Import('3DMF', 'File Format 3DMF', OneFile, imoptions)
						# new 9/22
						LocName=scene.CurrentActor.Name() # Get the name of newly loaded
						LocatablesList.append(LocName)

		elif self.Choice == 22:
			for OneFile in SelectedFiles:
				self.SpawnMT(OneFile)

		elif self.Choice == 23:
			for OneFile in SelectedFiles:
				Main,Ext=os.path.splitext(OneFile)
				Ext=string.upper(Ext)
				try:
					if string.count(Ext,'CR') or string.count(Ext,'PZ'):
						scene.LoadLibraryFigure(OneFile)
						# new 9/22
						LocName=scene.CurrentActor.Name() # Get the name of newly loaded
						LocatablesList.append(LocName)
					elif string.count(Ext,'PP'):
						scene.LoadLibraryProp(OneFile)
						# new 9/22
						LocName=scene.CurrentActor.Name() # Get the name of newly loaded
						LocatablesList.append(LocName)
					elif string.count(Ext,'Z2') or string.count(Ext,'2Z'):
						scene.LoadLibraryPose(OneFile)
					elif string.count(Ext,'HR'):
						scene.LoadLibraryHair(OneFile)
					elif string.count(Ext,'FC'):
						scene.LoadLibraryFace(OneFile)
					elif string.count(Ext,'HD'):
						scene.LoadLibraryHand(OneFile,0)
					elif string.count(Ext,'LT'):
						scene.LoadLibraryLight(OneFile)
					elif string.count(Ext,'CM'):
						scene.LoadLibraryCamera(OneFile)
				except:
					pass

		elif self.Choice == 24:
			for OneFile in SelectedFiles:
				Main,Ext=os.path.splitext(OneFile)
				Ext=string.upper(Ext)
				try:
					if string.count(Ext,'CR'):
						scene.LoadLibraryFigure(OneFile)
						# new 9/22
						LocName=scene.CurrentActor.Name() # Get the name of newly loaded
						LocatablesList.append(LocName)
					elif string.count(Ext,'PP'):
						scene.LoadLibraryProp(OneFile)
						# new 9/22
						LocName=scene.CurrentActor.Name() # Get the name of newly loaded
						LocatablesList.append(LocName)
					elif string.count(Ext,'Z2') or string.count(Ext,'2Z'):
						scene.LoadLibraryPose(OneFile)
					elif string.count(Ext,'HR'):
						scene.LoadLibraryHair(OneFile)
					elif string.count(Ext,'FC'):
						scene.LoadLibraryFace(OneFile)
					elif string.count(Ext,'HD'):
						scene.LoadLibraryHand(OneFile,0)
					elif string.count(Ext,'LT'):
						scene.LoadLibraryLight(OneFile)
					elif string.count(Ext,'CM'):
						scene.LoadLibraryCamera(OneFile)
				except:
					pass

				if string.count(Ext,'CR'):
					try:
						NewFig=scene.CurrentFigure()
					except:
						NewFig=0
					if BaseFig and NewFig:
						NewFig.SetConformTarget(BaseFig)
						scene.SelectFigure(BaseFig)
				else:
					try:
						NewActor=scene.CurrentActor()
						NewActor.SetParent(TryParent)
					except:
						pass

		if TryParent: self.Locate(TryParent) # New 9/22/04. Takes all 'solid' items in list

		self.FileListBox.selection_clear(0,END)
		self.FileTypeVar.set(0)
		self.Quantity=1
		self.QuantityEntry.delete(0,'end')
		self.QuantityEntry.insert(0,'1')
		scene.DrawAll()
		self.WriteIni()
		self.GoButton.update_idletasks()

root=Tk()
app=App(root, '')
app.Update()
root.mainloop()

