#------------------------------------------------------------
# Swapallmorphs.py
# Flip everything that has left-right names, as far as possible with standard morphs.
# Copyright (c) 2003 David G. Drumright (ockham)
#------------------------------------------------------------

import poser
scene = poser.Scene()

#-----------------------------------------------------------------------------
BaseFig = scene.CurrentFigure() # should have been set
if not BaseFig: exit

# Look for MTs that have same name except for Right/Left
MTList={} # Uppercase MT names as keys, actual names as values.

for OneParm in OneActor.Parameters():
    if OneParm.IsMorphTarget():
        N = OneParm.Name()
        MTList[string.upper(N)] = N

OppDict={}  # Keys are uppercase Left or L, vals are uppercase Right or R

# Try all four possible switchovers.  Ideally
# this should be only L/R and LEFT/RIGHT, but
# some commercial figures do have asymmetrical names.
# Also, when we check for plain L, we look only
# in first and last place.  Replacing L by R
# everywhere leads to things like
# DIMPLE L -> DIMPRE R .

for N in MTList.keys():
    if N[0]=='L':
        OppName = 'R' + N[1:]
        if OppName in MTList.keys():
            OppDict[N]=OppName
        OppName = string.replace(N,'L','RIGHT',1) # replace first L
        if OppName in MTList.keys():
            OppDict[N]=OppName

    elif N[-1]=='L':
        OppName = N[:-1]+'R'
        if OppName in MTList.keys():
            OppDict[N]=OppName
        OppName = N[:-1]+'RIGHT'
        if OppName in MTList.keys():
            OppDict[N]=OppName

    elif string.count(N,'LEFT'):
        OppName = string.replace(N,'LEFT','R')
        if OppName in MTList.keys():
            OppDict[N]=OppName
        OppName = string.replace(N,'LEFT','RIGHT')
        if OppName in MTList.keys():
            OppDict[N]=OppName

# Now use the OppDict to swap.
for UpperL in OppDict.keys():
    RealL = MTList[UpperL]
    UpperR = OppDict[UpperL]
    RealR = MTList[UpperR]
    Lval = OneActor.Parameter(RealL).Value()
    Rval = OneActor.Parameter(RealR).Value()
    OneActor.Parameter(RealR).SetValue(Lval)
    OneActor.Parameter(RealL).SetValue(Rval)

